diff --git a/gcc/final.c b/gcc/final.c
index 83abee2..9dac6c0 100644
--- a/gcc/final.c
+++ b/gcc/final.c
@@ -689,7 +689,7 @@ compute_alignments (void)
   label_align = XCNEWVEC (struct label_alignment, max_labelno - min_labelno + 1);
 
   /* If not optimizing or optimizing for size, don't assign any alignments.  */
-  if (! optimize || optimize_function_for_size_p (cfun))
+  if (! GCC_OPTION (optimize) || optimize_function_for_size_p (cfun))
     return 0;
 
   if (dump_file)
@@ -1039,10 +1039,10 @@ shorten_branches (rtx first)
      lengths as we find the need for this, till nothing changes.
      When not optimizing, we start assuming maximum lengths, and
      do a single pass to update the lengths.  */
-  bool increasing = optimize != 0;
+  bool increasing = GCC_OPTION (optimize) != 0;
 
 #ifdef CASE_VECTOR_SHORTEN_MODE
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       /* Look for ADDR_DIFF_VECs, and initialize their minimum and maximum
          label fields.  */
@@ -1268,7 +1268,7 @@ shorten_branches (rtx first)
 	  INSN_ADDRESSES (uid) = insn_current_address;
 
 #ifdef CASE_VECTOR_SHORTEN_MODE
-	  if (optimize
+	  if (GCC_OPTION (optimize)
 	      && JUMP_TABLE_DATA_P (insn)
 	      && GET_CODE (PATTERN (insn)) == ADDR_DIFF_VEC)
 	    {
@@ -1577,7 +1577,7 @@ remap_debug_filename (const char *filename)
 static bool
 dwarf2_debug_info_emitted_p (tree decl)
 {
-  if (write_symbols != DWARF2_DEBUG && write_symbols != VMS_AND_DWARF2_DEBUG)
+  if (GCC_OPTION (write_symbols) != DWARF2_DEBUG && GCC_OPTION (write_symbols) != VMS_AND_DWARF2_DEBUG)
     return false;
 
   if (DECL_IGNORED_P (decl))
@@ -1739,7 +1739,7 @@ final_start_function (rtx first, FILE *file,
 
   high_block_linenum = high_function_linenum = last_linenum;
 
-  if (flag_sanitize & SANITIZE_ADDRESS)
+  if (GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS)
     asan_function_start ();
 
   if (!DECL_IGNORED_P (current_function_decl))
@@ -1794,7 +1794,7 @@ final_start_function (rtx first, FILE *file,
 
   /* If debugging, assign block numbers to all of the blocks in this
      function.  */
-  if (write_symbols)
+  if (GCC_OPTION (write_symbols))
     {
       reemit_insn_block_notes ();
       number_blocks (current_function_decl);
@@ -1804,13 +1804,13 @@ final_start_function (rtx first, FILE *file,
       TREE_ASM_WRITTEN (DECL_INITIAL (current_function_decl)) = 1;
     }
 
-  if (warn_frame_larger_than
-    && get_frame_size () > frame_larger_than_size)
+  if (GCC_OPTION (warn_frame_larger_than)
+    && get_frame_size () > GCC_OPTION (frame_larger_than_size))
   {
       /* Issue a warning */
       warning (OPT_Wframe_larger_than_,
                "the frame size of %wd bytes is larger than %wd bytes",
-               get_frame_size (), frame_larger_than_size);
+               get_frame_size (), GCC_OPTION (frame_larger_than_size));
   }
 
   /* First output the function prologue: code to set up the stack frame.  */
@@ -1910,7 +1910,7 @@ dump_basic_block_info (FILE *file, rtx insn, basic_block *start_to_bb,
 {
   basic_block bb;
 
-  if (!flag_debug_asm)
+  if (!GCC_OPTION (flag_debug_asm))
     return;
 
   if (INSN_UID (insn) < bb_map_size
@@ -1985,7 +1985,7 @@ final (rtx first, FILE *file, int optimize_p)
 
   CC_STATUS_INIT;
 
-  if (flag_debug_asm)
+  if (GCC_OPTION (flag_debug_asm))
     {
       basic_block bb;
 
@@ -2023,7 +2023,7 @@ final (rtx first, FILE *file, int optimize_p)
       insn = final_scan_insn (insn, file, optimize_p, 0, &seen);
     }
 
-  if (flag_debug_asm)
+  if (GCC_OPTION (flag_debug_asm))
     {
       free (start_to_bb);
       free (end_to_bb);
@@ -2251,11 +2251,11 @@ final_scan_insn (rtx insn, FILE *file, int optimize_p ATTRIBUTE_UNUSED,
 	  break;
 
 	case NOTE_INSN_BLOCK_BEG:
-	  if (debug_info_level == DINFO_LEVEL_NORMAL
-	      || debug_info_level == DINFO_LEVEL_VERBOSE
-	      || write_symbols == DWARF2_DEBUG
-	      || write_symbols == VMS_AND_DWARF2_DEBUG
-	      || write_symbols == VMS_DEBUG)
+	  if (GCC_OPTION (debug_info_level) == DINFO_LEVEL_NORMAL
+	      || GCC_OPTION (debug_info_level) == DINFO_LEVEL_VERBOSE
+	      || GCC_OPTION (write_symbols) == DWARF2_DEBUG
+	      || GCC_OPTION (write_symbols) == VMS_AND_DWARF2_DEBUG
+	      || GCC_OPTION (write_symbols) == VMS_DEBUG)
 	    {
 	      int n = BLOCK_NUMBER (NOTE_BLOCK (insn));
 
@@ -2270,8 +2270,8 @@ final_scan_insn (rtx insn, FILE *file, int optimize_p ATTRIBUTE_UNUSED,
 	      /* Mark this block as output.  */
 	      TREE_ASM_WRITTEN (NOTE_BLOCK (insn)) = 1;
 	    }
-	  if (write_symbols == DBX_DEBUG
-	      || write_symbols == SDB_DEBUG)
+	  if (GCC_OPTION (write_symbols) == DBX_DEBUG
+	      || GCC_OPTION (write_symbols) == SDB_DEBUG)
 	    {
 	      location_t *locus_ptr
 		= block_nonartificial_location (NOTE_BLOCK (insn));
@@ -2285,11 +2285,11 @@ final_scan_insn (rtx insn, FILE *file, int optimize_p ATTRIBUTE_UNUSED,
 	  break;
 
 	case NOTE_INSN_BLOCK_END:
-	  if (debug_info_level == DINFO_LEVEL_NORMAL
-	      || debug_info_level == DINFO_LEVEL_VERBOSE
-	      || write_symbols == DWARF2_DEBUG
-	      || write_symbols == VMS_AND_DWARF2_DEBUG
-	      || write_symbols == VMS_DEBUG)
+	  if (GCC_OPTION (debug_info_level) == DINFO_LEVEL_NORMAL
+	      || GCC_OPTION (debug_info_level) == DINFO_LEVEL_VERBOSE
+	      || GCC_OPTION (write_symbols) == DWARF2_DEBUG
+	      || GCC_OPTION (write_symbols) == VMS_AND_DWARF2_DEBUG
+	      || GCC_OPTION (write_symbols) == VMS_DEBUG)
 	    {
 	      int n = BLOCK_NUMBER (NOTE_BLOCK (insn));
 
@@ -2302,8 +2302,8 @@ final_scan_insn (rtx insn, FILE *file, int optimize_p ATTRIBUTE_UNUSED,
 	      if (!DECL_IGNORED_P (current_function_decl))
 		debug_hooks->end_block (high_block_linenum, n);
 	    }
-	  if (write_symbols == DBX_DEBUG
-	      || write_symbols == SDB_DEBUG)
+	  if (GCC_OPTION (write_symbols) == DBX_DEBUG
+	      || GCC_OPTION (write_symbols) == SDB_DEBUG)
 	    {
 	      tree outer_block = BLOCK_SUPERCONTEXT (NOTE_BLOCK (insn));
 	      location_t *locus_ptr
@@ -2835,7 +2835,7 @@ final_scan_insn (rtx insn, FILE *file, int optimize_p ATTRIBUTE_UNUSED,
 #ifdef HAVE_peephole
 	/* Do machine-specific peephole optimizations if desired.  */
 
-	if (optimize_p && !flag_no_peephole && !nopeepholes)
+	if (optimize_p && !GCC_OPTION (flag_no_peephole) && !nopeepholes)
 	  {
 	    rtx next = peephole (insn);
 	    /* When peepholing, if there were notes within the peephole,
@@ -2877,7 +2877,7 @@ final_scan_insn (rtx insn, FILE *file, int optimize_p ATTRIBUTE_UNUSED,
 	/* Dump the insn in the assembly for debugging (-dAP).
 	   If the final dump is requested as slim RTL, dump slim
 	   RTL to the assembly file also.  */
-	if (flag_dump_rtl_in_asm)
+	if (GCC_OPTION (flag_dump_rtl_in_asm))
 	  {
 	    print_rtx_head = ASM_COMMENT_START;
 	    if (! (dump_flags & TDF_SLIM))
@@ -3607,9 +3607,9 @@ output_asm_insn (const char *templ, rtx *operands)
     switch (c)
       {
       case '\n':
-	if (flag_verbose_asm)
+	if (GCC_OPTION (flag_verbose_asm))
 	  output_asm_operand_names (operands, oporder, ops);
-	if (flag_print_asm_name)
+	if (GCC_OPTION (flag_print_asm_name))
 	  output_asm_name ();
 
 	ops = 0;
@@ -3738,9 +3738,9 @@ output_asm_insn (const char *templ, rtx *operands)
       }
 
   /* Write out the variable names for operands, if we know them.  */
-  if (flag_verbose_asm)
+  if (GCC_OPTION (flag_verbose_asm))
     output_asm_operand_names (operands, oporder, ops);
-  if (flag_print_asm_name)
+  if (GCC_OPTION (flag_print_asm_name))
     output_asm_name ();
 
   putc ('\n', asm_out_file);
@@ -4240,7 +4240,7 @@ leaf_function_p (void)
 {
   rtx insn;
 
-  if (crtl->profile || profile_arc_flag)
+  if (crtl->profile || GCC_OPTION (profile_arc_flag))
     return 0;
 
   for (insn = get_insns (); insn; insn = NEXT_INSN (insn))
@@ -4423,8 +4423,8 @@ rest_of_handle_final (void)
   fnname = XSTR (x, 0);
 
   assemble_start_function (current_function_decl, fnname);
-  final_start_function (get_insns (), asm_out_file, optimize);
-  final (get_insns (), asm_out_file, optimize);
+  final_start_function (get_insns (), asm_out_file, GCC_OPTION (optimize));
+  final (get_insns (), asm_out_file, GCC_OPTION (optimize));
   final_end_function ();
 
   /* The IA-64 ".handlerdata" directive must be issued before the ".endp"
@@ -4439,7 +4439,7 @@ rest_of_handle_final (void)
   /* Free up reg info memory.  */
   free_reg_info ();
 
-  if (! quiet_flag)
+  if (! GCC_OPTION (quiet_flag))
     fflush (asm_out_file);
 
   /* Write DBX symbols if requested.  */
@@ -4563,22 +4563,22 @@ rest_of_clean_state (void)
 {
   rtx insn, next;
   FILE *final_output = NULL;
-  int save_unnumbered = flag_dump_unnumbered;
-  int save_noaddr = flag_dump_noaddr;
+  int save_unnumbered = GCC_OPTION (flag_dump_unnumbered);
+  int save_noaddr = GCC_OPTION (flag_dump_noaddr);
 
-  if (flag_dump_final_insns)
+  if (GCC_OPTION (flag_dump_final_insns))
     {
-      final_output = fopen (flag_dump_final_insns, "a");
+      final_output = fopen (GCC_OPTION (flag_dump_final_insns), "a");
       if (!final_output)
 	{
 	  error ("could not open final insn dump file %qs: %m",
-		 flag_dump_final_insns);
-	  flag_dump_final_insns = NULL;
+		 GCC_OPTION (flag_dump_final_insns));
+	  GCC_OPTION (flag_dump_final_insns) = NULL;
 	}
       else
 	{
-	  flag_dump_noaddr = flag_dump_unnumbered = 1;
-	  if (flag_compare_debug_opt || flag_compare_debug)
+	  GCC_OPTION (flag_dump_noaddr) = GCC_OPTION (flag_dump_unnumbered) = 1;
+	  if (GCC_OPTION (flag_compare_debug_opt) || GCC_OPTION (flag_compare_debug))
 	    dump_flags |= TDF_NOUID;
 	  dump_function_header (final_output, current_function_decl,
 				dump_flags);
@@ -4618,15 +4618,15 @@ rest_of_clean_state (void)
 
   if (final_output)
     {
-      flag_dump_noaddr = save_noaddr;
-      flag_dump_unnumbered = save_unnumbered;
+      GCC_OPTION (flag_dump_noaddr) = save_noaddr;
+      GCC_OPTION (flag_dump_unnumbered) = save_unnumbered;
       final_insns_dump_p = false;
 
       if (fclose (final_output))
 	{
 	  error ("could not close final insn dump file %qs: %m",
-		 flag_dump_final_insns);
-	  flag_dump_final_insns = NULL;
+		 GCC_OPTION (flag_dump_final_insns));
+	  GCC_OPTION (flag_dump_final_insns) = NULL;
 	}
     }
 
@@ -4634,7 +4634,7 @@ rest_of_clean_state (void)
      don't leave any temporary anonymous types
      queued up for sdb output.  */
 #ifdef SDB_DEBUGGING_INFO
-  if (write_symbols == SDB_DEBUG)
+  if (GCC_OPTION (write_symbols) == SDB_DEBUG)
     sdbout_types (NULL_TREE);
 #endif
 
diff --git a/gcc/flags.h b/gcc/flags.h
index 475d428..cfbdbc4 100644
--- a/gcc/flags.h
+++ b/gcc/flags.h
@@ -91,10 +91,10 @@ extern struct target_flag_state *this_target_flag_state;
    greater is in use.  */
 
 #define abi_version_at_least(N) \
-  (flag_abi_version == 0 || flag_abi_version >= (N))
+  (GCC_OPTION (flag_abi_version) == 0 || GCC_OPTION (flag_abi_version) >= (N))
 
 /* Whether to emit an overflow warning whose code is C.  */
-#define issue_strict_overflow_warning(c) (warn_strict_overflow >= (int) (c))
+#define issue_strict_overflow_warning(c) (GCC_OPTION (warn_strict_overflow) >= (int) (c))
 
 #endif
 
diff --git a/gcc/fold-const.c b/gcc/fold-const.c
index 891c0d5..b08c26f 100644
--- a/gcc/fold-const.c
+++ b/gcc/fold-const.c
@@ -352,7 +352,7 @@ negate_mathfn_p (enum built_in_function code)
     CASE_FLT_FN (BUILT_IN_LRINT):
     CASE_FLT_FN (BUILT_IN_NEARBYINT):
     CASE_FLT_FN (BUILT_IN_RINT):
-      return !flag_rounding_math;
+      return !GCC_OPTION (flag_rounding_math);
 
     default:
       break;
@@ -575,7 +575,7 @@ fold_negate_expr (location_t loc, tree t)
     case REAL_CST:
       tem = fold_negate_const (t, type);
       /* Two's complement FP formats, such as c4x, may overflow.  */
-      if (!TREE_OVERFLOW (tem) || !flag_trapping_math)
+      if (!TREE_OVERFLOW (tem) || !GCC_OPTION (flag_trapping_math))
 	return tem;
       break;
 
@@ -830,7 +830,7 @@ split_tree (tree in, enum tree_code code, tree *conp, tree *litp,
       || TREE_CODE (in) == FIXED_CST)
     *litp = in;
   else if (TREE_CODE (in) == code
-	   || ((! FLOAT_TYPE_P (TREE_TYPE (in)) || flag_associative_math)
+	   || ((! FLOAT_TYPE_P (TREE_TYPE (in)) || GCC_OPTION (flag_associative_math))
 	       && ! SAT_FIXED_POINT_TYPE_P (TREE_TYPE (in))
 	       /* We can associate addition and subtraction together (even
 		  though the C standard doesn't say so) for integers because
@@ -1212,7 +1212,7 @@ const_binop (enum tree_code code, tree arg1, tree arg2)
 	 by zero exception.  */
       if (code == RDIV_EXPR
 	  && REAL_VALUES_EQUAL (d2, dconst0)
-	  && (flag_trapping_math || ! MODE_HAS_INFINITIES (mode)))
+	  && (GCC_OPTION (flag_trapping_math) || ! MODE_HAS_INFINITIES (mode)))
 	return NULL_TREE;
 
       /* If either operand is a NaN, just return it.  Otherwise, set up
@@ -1227,7 +1227,7 @@ const_binop (enum tree_code code, tree arg1, tree arg2)
 
       /* Don't constant fold this floating point operation if
 	 the result has overflowed and flag_trapping_math.  */
-      if (flag_trapping_math
+      if (GCC_OPTION (flag_trapping_math)
 	  && MODE_HAS_INFINITIES (mode)
 	  && REAL_VALUE_ISINF (result)
 	  && !REAL_VALUE_ISINF (d1)
@@ -1238,8 +1238,8 @@ const_binop (enum tree_code code, tree arg1, tree arg2)
 	 result may dependent upon the run-time rounding mode and
 	 flag_rounding_math is set, or if GCC's software emulation
 	 is unable to accurately represent the result.  */
-      if ((flag_rounding_math
-	   || (MODE_COMPOSITE_P (mode) && !flag_unsafe_math_optimizations))
+      if ((GCC_OPTION (flag_rounding_math)
+	   || (MODE_COMPOSITE_P (mode) && !GCC_OPTION (flag_unsafe_math_optimizations)))
 	  && (inexact || !real_identical (&result, &value)))
 	return NULL_TREE;
 
@@ -1331,7 +1331,7 @@ const_binop (enum tree_code code, tree arg1, tree arg2)
 	case CEIL_DIV_EXPR:
 	case FLOOR_DIV_EXPR:
 	case ROUND_DIV_EXPR:
-	  if (flag_complex_method == 0)
+	  if (GCC_OPTION (flag_complex_method) == 0)
 	  {
 	    /* Keep this algorithm in sync with
 	       tree-complex.c:expand_complex_div_straight().
@@ -2208,7 +2208,7 @@ pedantic_non_lvalue_loc (location_t loc, tree x)
 enum tree_code
 invert_tree_comparison (enum tree_code code, bool honor_nans)
 {
-  if (honor_nans && flag_trapping_math && code != EQ_EXPR && code != NE_EXPR
+  if (honor_nans && GCC_OPTION (flag_trapping_math) && code != EQ_EXPR && code != NE_EXPR
       && code != ORDERED_EXPR && code != UNORDERED_EXPR)
     return ERROR_MARK;
 
@@ -2409,7 +2409,7 @@ combine_comparisons (location_t loc,
       else if (compcode == COMPCODE_ORD)
 	compcode = COMPCODE_TRUE;
     }
-   else if (flag_trapping_math)
+   else if (GCC_OPTION (flag_trapping_math))
      {
 	/* Check that the original operation and the optimized ones will trap
 	   under the same condition.  */
@@ -3180,7 +3180,7 @@ fold_truth_not_expr (location_t loc, tree arg)
     {
       tree op_type = TREE_TYPE (TREE_OPERAND (arg, 0));
       if (FLOAT_TYPE_P (op_type)
-	  && flag_trapping_math
+	  && GCC_OPTION (flag_trapping_math)
 	  && code != ORDERED_EXPR && code != UNORDERED_EXPR
 	  && code != NE_EXPR && code != EQ_EXPR)
 	return NULL_TREE;
@@ -4732,7 +4732,7 @@ fold_cond_expr_with_comparison (location_t loc, tree type,
 	return pedantic_non_lvalue_loc (loc, fold_convert_loc (loc, type, arg1));
       case UNGE_EXPR:
       case UNGT_EXPR:
-	if (flag_trapping_math)
+	if (GCC_OPTION (flag_trapping_math))
 	  break;
 	/* Fall through.  */
       case GE_EXPR:
@@ -4744,7 +4744,7 @@ fold_cond_expr_with_comparison (location_t loc, tree type,
 	return pedantic_non_lvalue_loc (loc, fold_convert_loc (loc, type, tem));
       case UNLE_EXPR:
       case UNLT_EXPR:
-	if (flag_trapping_math)
+	if (GCC_OPTION (flag_trapping_math))
 	  break;
       case LE_EXPR:
       case LT_EXPR:
@@ -6680,7 +6680,7 @@ fold_single_bit_test (location_t loc, enum tree_code code,
 	 Normally unsigned is faster, but for some machines signed is.  */
 #ifdef LOAD_EXTEND_OP
       ops_unsigned = (LOAD_EXTEND_OP (operand_mode) == SIGN_EXTEND
-		      && !flag_syntax_only) ? 0 : 1;
+		      && !GCC_OPTION (flag_syntax_only)) ? 0 : 1;
 #else
       ops_unsigned = 1;
 #endif
@@ -6716,7 +6716,7 @@ fold_single_bit_test (location_t loc, enum tree_code code,
 static bool
 reorder_operands_p (const_tree arg0, const_tree arg1)
 {
-  if (! flag_evaluation_order)
+  if (! GCC_OPTION (flag_evaluation_order))
       return true;
   if (TREE_CONSTANT (arg0) || TREE_CONSTANT (arg1))
     return true;
@@ -6763,7 +6763,7 @@ tree_swap_operands_p (const_tree arg0, const_tree arg1, bool reorder)
   if (optimize_function_for_size_p (cfun))
     return 0;
 
-  if (reorder && flag_evaluation_order
+  if (reorder && GCC_OPTION (flag_evaluation_order)
       && (TREE_SIDE_EFFECTS (arg0) || TREE_SIDE_EFFECTS (arg1)))
     return 0;
 
@@ -7922,7 +7922,7 @@ fold_unary_loc (location_t loc, enum tree_code code, tree type, tree op0)
 		     && (INTEGRAL_TYPE_P
 			 (TREE_TYPE (TREE_OPERAND (TREE_OPERAND (tem, 1), 0))))
 		     && TYPE_PRECISION (TREE_TYPE (tem)) <= BITS_PER_WORD)
-		  || flag_syntax_only))
+		  || GCC_OPTION (flag_syntax_only)))
 	    tem = build1_loc (loc, code, type,
 			      build3 (COND_EXPR,
 				      TREE_TYPE (TREE_OPERAND
@@ -8131,7 +8131,7 @@ fold_unary_loc (location_t loc, enum tree_code code, tree type, tree op0)
 	      change = (cst == 0);
 #ifdef LOAD_EXTEND_OP
 	      if (change
-		  && !flag_syntax_only
+		  && !GCC_OPTION (flag_syntax_only)
 		  && (LOAD_EXTEND_OP (TYPE_MODE (TREE_TYPE (and0)))
 		      == ZERO_EXTEND))
 		{
@@ -8594,7 +8594,7 @@ fold_truth_andor (location_t loc, enum tree_code code, tree type,
   tree tem;
 
   /* We only do these simplifications if we are optimizing.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return NULL_TREE;
 
   /* Check for things like (A || B) && (A || C).  We can convert this
@@ -9456,7 +9456,7 @@ fold_comparison (location_t loc, enum tree_code code, tree type,
 	 or a MINUS_EXPR of a real constant, we can convert it into a
 	 comparison with a revised real constant as long as no overflow
 	 occurs when unsafe_math_optimizations are enabled.  */
-      if (flag_unsafe_math_optimizations
+      if (GCC_OPTION (flag_unsafe_math_optimizations)
 	  && TREE_CODE (arg1) == REAL_CST
 	  && (TREE_CODE (arg0) == PLUS_EXPR
 	      || TREE_CODE (arg0) == MINUS_EXPR)
@@ -9471,7 +9471,7 @@ fold_comparison (location_t loc, enum tree_code code, tree type,
          a MINUS_EXPR whose first operand is also a real constant, i.e.
          (c1 - x) < c2 becomes x > c1-c2.  Reordering is allowed on
          floating-point types only if -fassociative-math is set.  */
-      if (flag_associative_math
+      if (GCC_OPTION (flag_associative_math)
 	  && TREE_CODE (arg1) == REAL_CST
 	  && TREE_CODE (arg0) == MINUS_EXPR
 	  && TREE_CODE (TREE_OPERAND (arg0, 0)) == REAL_CST
@@ -9483,8 +9483,8 @@ fold_comparison (location_t loc, enum tree_code code, tree type,
 
       /* Fold comparisons against built-in math functions.  */
       if (TREE_CODE (arg1) == REAL_CST
-	  && flag_unsafe_math_optimizations
-	  && ! flag_errno_math)
+	  && GCC_OPTION (flag_unsafe_math_optimizations)
+	  && ! GCC_OPTION (flag_errno_math))
 	{
 	  enum built_in_function fcode = builtin_mathfn_code (arg0);
 
@@ -10062,11 +10062,11 @@ tree_expr_nonzero_warnv_p (tree t, bool *strict_overflow_p)
       {
 	tree fndecl = get_callee_fndecl (t);
 	if (!fndecl) return false;
-	if (flag_delete_null_pointer_checks && !flag_check_new
+	if (GCC_OPTION (flag_delete_null_pointer_checks) && !GCC_OPTION (flag_check_new)
 	    && DECL_IS_OPERATOR_NEW (fndecl)
 	    && !TREE_NOTHROW (fndecl))
 	  return true;
-	if (flag_delete_null_pointer_checks
+	if (GCC_OPTION (flag_delete_null_pointer_checks)
 	    && lookup_attribute ("returns_nonnull",
 		 TYPE_ATTRIBUTES (TREE_TYPE (fndecl))))
 	  return true;
@@ -10351,7 +10351,7 @@ fold_binary_loc (location_t loc,
     case PLUS_EXPR:
       /* A + (-B) -> A - B */
       if (TREE_CODE (arg1) == NEGATE_EXPR
-	  && (flag_sanitize & SANITIZE_SI_OVERFLOW) == 0)
+	  && (GCC_OPTION (flag_sanitize) & SANITIZE_SI_OVERFLOW) == 0)
 	return fold_build2_loc (loc, MINUS_EXPR, type,
 			    fold_convert_loc (loc, type, arg0),
 			    fold_convert_loc (loc, type,
@@ -10359,7 +10359,7 @@ fold_binary_loc (location_t loc,
       /* (-A) + B -> B - A */
       if (TREE_CODE (arg0) == NEGATE_EXPR
 	  && reorder_operands_p (TREE_OPERAND (arg0, 0), arg1)
-	  && (flag_sanitize & SANITIZE_SI_OVERFLOW) == 0)
+	  && (GCC_OPTION (flag_sanitize) & SANITIZE_SI_OVERFLOW) == 0)
 	return fold_build2_loc (loc, MINUS_EXPR, type,
 			    fold_convert_loc (loc, type, arg1),
 			    fold_convert_loc (loc, type,
@@ -10429,7 +10429,7 @@ fold_binary_loc (location_t loc,
 	  && !TYPE_SATURATING (type)
 	  && TYPE_UNSIGNED (type) == TYPE_UNSIGNED (TREE_TYPE (arg0))
 	  && TYPE_UNSIGNED (type) == TYPE_UNSIGNED (TREE_TYPE (arg1))
-	  && (!FLOAT_TYPE_P (type) || flag_associative_math))
+	  && (!FLOAT_TYPE_P (type) || GCC_OPTION (flag_associative_math)))
         {
 	  tree tem = fold_plusminus_mult_expr (loc, code, type, arg0, arg1);
 	  if (tem)
@@ -10516,7 +10516,7 @@ fold_binary_loc (location_t loc,
 	      && REAL_VALUE_NEGATIVE (TREE_REAL_CST (arg1)))
 	    {
 	      tem = fold_negate_const (arg1, type);
-	      if (!TREE_OVERFLOW (arg1) || !flag_trapping_math)
+	      if (!TREE_OVERFLOW (arg1) || !GCC_OPTION (flag_trapping_math))
 		return fold_build2_loc (loc, MINUS_EXPR, type,
 				    fold_convert_loc (loc, type, arg0),
 				    fold_convert_loc (loc, type, tem));
@@ -10557,7 +10557,7 @@ fold_binary_loc (location_t loc,
 		}
 	    }
 
-	  if (flag_unsafe_math_optimizations
+	  if (GCC_OPTION (flag_unsafe_math_optimizations)
 	      && (TREE_CODE (arg0) == RDIV_EXPR || TREE_CODE (arg0) == MULT_EXPR)
 	      && (TREE_CODE (arg1) == RDIV_EXPR || TREE_CODE (arg1) == MULT_EXPR)
 	      && (tem = distribute_real_division (loc, code, type, arg0, arg1)))
@@ -10572,7 +10572,7 @@ fold_binary_loc (location_t loc,
           /* Convert a + (b*c + d*e) into (a + b*c) + d*e.
              We associate floats only if the user has specified
              -fassociative-math.  */
-          if (flag_associative_math
+          if (GCC_OPTION (flag_associative_math)
               && TREE_CODE (arg1) == PLUS_EXPR
               && TREE_CODE (arg0) != MULT_EXPR)
             {
@@ -10589,7 +10589,7 @@ fold_binary_loc (location_t loc,
           /* Convert (b*c + d*e) + a into b*c + (d*e +a).
              We associate floats only if the user has specified
              -fassociative-math.  */
-          if (flag_associative_math
+          if (GCC_OPTION (flag_associative_math)
               && TREE_CODE (arg0) == PLUS_EXPR
               && TREE_CODE (arg1) != MULT_EXPR)
             {
@@ -10700,7 +10700,7 @@ fold_binary_loc (location_t loc,
 	 -fassociative-math.
 	 And, we need to make sure type is not saturating.  */
 
-      if ((! FLOAT_TYPE_P (type) || flag_associative_math)
+      if ((! FLOAT_TYPE_P (type) || GCC_OPTION (flag_associative_math))
 	  && !TYPE_SATURATING (type))
 	{
 	  tree var0, con0, lit0, minus_lit0;
@@ -11057,7 +11057,7 @@ fold_binary_loc (location_t loc,
 	}
 
       if (FLOAT_TYPE_P (type)
-	  && flag_unsafe_math_optimizations
+	  && GCC_OPTION (flag_unsafe_math_optimizations)
 	  && (TREE_CODE (arg0) == RDIV_EXPR || TREE_CODE (arg0) == MULT_EXPR)
 	  && (TREE_CODE (arg1) == RDIV_EXPR || TREE_CODE (arg1) == MULT_EXPR)
 	  && (tem = distribute_real_division (loc, code, type, arg0, arg1)))
@@ -11072,7 +11072,7 @@ fold_binary_loc (location_t loc,
 	  && !TYPE_SATURATING (type)
 	  && TYPE_UNSIGNED (type) == TYPE_UNSIGNED (TREE_TYPE (arg0))
 	  && TYPE_UNSIGNED (type) == TYPE_UNSIGNED (TREE_TYPE (arg1))
-	  && (!FLOAT_TYPE_P (type) || flag_associative_math))
+	  && (!FLOAT_TYPE_P (type) || GCC_OPTION (flag_associative_math)))
         {
 	  tree tem = fold_plusminus_mult_expr (loc, code, type, arg0, arg1);
 	  if (tem)
@@ -11196,7 +11196,7 @@ fold_binary_loc (location_t loc,
 	  /* Convert (C1/X)*C2 into (C1*C2)/X.  This transformation may change
              the result for floating point types due to rounding so it is applied
              only if -fassociative-math was specify.  */
-	  if (flag_associative_math
+	  if (GCC_OPTION (flag_associative_math)
 	      && TREE_CODE (arg0) == RDIV_EXPR
 	      && TREE_CODE (arg1) == REAL_CST
 	      && TREE_CODE (TREE_OPERAND (arg0, 0)) == REAL_CST)
@@ -11246,16 +11246,16 @@ fold_binary_loc (location_t loc,
 	  /* Optimize z * conj(z) for floating point complex numbers.
 	     Guarded by flag_unsafe_math_optimizations as non-finite
 	     imaginary components don't produce scalar results.  */
-	  if (flag_unsafe_math_optimizations
+	  if (GCC_OPTION (flag_unsafe_math_optimizations)
 	      && TREE_CODE (arg0) == CONJ_EXPR
 	      && operand_equal_p (TREE_OPERAND (arg0, 0), arg1, 0))
 	    return fold_mult_zconjz (loc, type, arg1);
-	  if (flag_unsafe_math_optimizations
+	  if (GCC_OPTION (flag_unsafe_math_optimizations)
 	      && TREE_CODE (arg1) == CONJ_EXPR
 	      && operand_equal_p (arg0, TREE_OPERAND (arg1, 0), 0))
 	    return fold_mult_zconjz (loc, type, arg0);
 
-	  if (flag_unsafe_math_optimizations)
+	  if (GCC_OPTION (flag_unsafe_math_optimizations))
 	    {
 	      enum built_in_function fcode0 = builtin_mathfn_code (arg0);
 	      enum built_in_function fcode1 = builtin_mathfn_code (arg1);
@@ -11381,7 +11381,7 @@ fold_binary_loc (location_t loc,
 
 	      /* Canonicalize x*x as pow(x,2.0), which is expanded as x*x.  */
 	      if (!in_gimple_form
-		  && optimize
+		  && GCC_OPTION (optimize)
 		  && operand_equal_p (arg0, arg1, 0))
 		{
 		  tree powfn = mathfn_built_in (type, BUILT_IN_POW);
@@ -12210,14 +12210,14 @@ fold_binary_loc (location_t loc,
 	 so only do this if -freciprocal-math.  We can actually
 	 always safely do it if ARG1 is a power of two, but it's hard to
 	 tell if it is or not in a portable manner.  */
-      if (optimize
+      if (GCC_OPTION (optimize)
 	  && (TREE_CODE (arg1) == REAL_CST
 	      || (TREE_CODE (arg1) == COMPLEX_CST
 		  && COMPLEX_FLOAT_TYPE_P (TREE_TYPE (arg1)))
 	      || (TREE_CODE (arg1) == VECTOR_CST
 		  && VECTOR_FLOAT_TYPE_P (TREE_TYPE (arg1)))))
 	{
-	  if (flag_reciprocal_math
+	  if (GCC_OPTION (flag_reciprocal_math)
 	      && 0 != (tem = const_binop (code, build_one_cst (type), arg1)))
 	    return fold_build2_loc (loc, MULT_EXPR, type, arg0, tem);
 	  /* Find the reciprocal if optimizing and the result is exact.
@@ -12231,14 +12231,14 @@ fold_binary_loc (location_t loc,
 	    }
 	}
       /* Convert A/B/C to A/(B*C).  */
-      if (flag_reciprocal_math
+      if (GCC_OPTION (flag_reciprocal_math)
 	  && TREE_CODE (arg0) == RDIV_EXPR)
 	return fold_build2_loc (loc, RDIV_EXPR, type, TREE_OPERAND (arg0, 0),
 			    fold_build2_loc (loc, MULT_EXPR, type,
 					 TREE_OPERAND (arg0, 1), arg1));
 
       /* Convert A/(B/C) to (A/B)*C.  */
-      if (flag_reciprocal_math
+      if (GCC_OPTION (flag_reciprocal_math)
 	  && TREE_CODE (arg1) == RDIV_EXPR)
 	return fold_build2_loc (loc, MULT_EXPR, type,
 			    fold_build2_loc (loc, RDIV_EXPR, type, arg0,
@@ -12246,7 +12246,7 @@ fold_binary_loc (location_t loc,
 			    TREE_OPERAND (arg1, 1));
 
       /* Convert C1/(X*C2) into (C1/C2)/X.  */
-      if (flag_reciprocal_math
+      if (GCC_OPTION (flag_reciprocal_math)
 	  && TREE_CODE (arg1) == MULT_EXPR
 	  && TREE_CODE (arg0) == REAL_CST
 	  && TREE_CODE (TREE_OPERAND (arg1, 1)) == REAL_CST)
@@ -12258,7 +12258,7 @@ fold_binary_loc (location_t loc,
 				TREE_OPERAND (arg1, 0));
 	}
 
-      if (flag_unsafe_math_optimizations)
+      if (GCC_OPTION (flag_unsafe_math_optimizations))
 	{
 	  enum built_in_function fcode0 = builtin_mathfn_code (arg0);
 	  enum built_in_function fcode1 = builtin_mathfn_code (arg1);
@@ -13253,7 +13253,7 @@ fold_binary_loc (location_t loc,
 	   || TREE_CODE (arg0) == BIT_FIELD_REF)
 	  /* Handle the constant case even without -O
 	     to make sure the warnings are given.  */
-	  && (optimize || TREE_CODE (arg1) == INTEGER_CST))
+	  && (GCC_OPTION (optimize) || TREE_CODE (arg1) == INTEGER_CST))
 	{
 	  t1 = optimize_bit_field_compare (loc, code, type, arg0, arg1);
 	  if (t1)
@@ -13966,7 +13966,7 @@ fold_binary_loc (location_t loc,
       /* If the first operand is NaN, the result is constant.  */
       if (TREE_CODE (arg0) == REAL_CST
 	  && REAL_VALUE_ISNAN (TREE_REAL_CST (arg0))
-	  && (code != LTGT_EXPR || ! flag_trapping_math))
+	  && (code != LTGT_EXPR || ! GCC_OPTION (flag_trapping_math)))
 	{
 	  t1 = (code == ORDERED_EXPR || code == LTGT_EXPR)
 	       ? integer_zero_node
@@ -13977,7 +13977,7 @@ fold_binary_loc (location_t loc,
       /* If the second operand is NaN, the result is constant.  */
       if (TREE_CODE (arg1) == REAL_CST
 	  && REAL_VALUE_ISNAN (TREE_REAL_CST (arg1))
-	  && (code != LTGT_EXPR || ! flag_trapping_math))
+	  && (code != LTGT_EXPR || ! GCC_OPTION (flag_trapping_math)))
 	{
 	  t1 = (code == ORDERED_EXPR || code == LTGT_EXPR)
 	       ? integer_zero_node
@@ -13991,7 +13991,7 @@ fold_binary_loc (location_t loc,
 	return constant_boolean_node (1, type);
 
       if (code == LTGT_EXPR
-	  && !flag_trapping_math
+	  && !GCC_OPTION (flag_trapping_math)
 	  && operand_equal_p (arg0, arg1, 0))
 	return constant_boolean_node (0, type);
 
@@ -15345,22 +15345,22 @@ fold_build_call_array_loc (location_t loc, tree type, tree fn,
    potential run-time traps and exceptions that fold must preserve.  */
 
 #define START_FOLD_INIT \
-  int saved_signaling_nans = flag_signaling_nans;\
-  int saved_trapping_math = flag_trapping_math;\
-  int saved_rounding_math = flag_rounding_math;\
-  int saved_trapv = flag_trapv;\
+  int saved_signaling_nans = GCC_OPTION (flag_signaling_nans);\
+  int saved_trapping_math = GCC_OPTION (flag_trapping_math);\
+  int saved_rounding_math = GCC_OPTION (flag_rounding_math);\
+  int saved_trapv = GCC_OPTION (flag_trapv);\
   int saved_folding_initializer = folding_initializer;\
-  flag_signaling_nans = 0;\
-  flag_trapping_math = 0;\
-  flag_rounding_math = 0;\
-  flag_trapv = 0;\
+  GCC_OPTION (flag_signaling_nans) = 0;\
+  GCC_OPTION (flag_trapping_math) = 0;\
+  GCC_OPTION (flag_rounding_math) = 0;\
+  GCC_OPTION (flag_trapv) = 0;\
   folding_initializer = 1;
 
 #define END_FOLD_INIT \
-  flag_signaling_nans = saved_signaling_nans;\
-  flag_trapping_math = saved_trapping_math;\
-  flag_rounding_math = saved_rounding_math;\
-  flag_trapv = saved_trapv;\
+  GCC_OPTION (flag_signaling_nans) = saved_signaling_nans;\
+  GCC_OPTION (flag_trapping_math) = saved_trapping_math;\
+  GCC_OPTION (flag_rounding_math) = saved_rounding_math;\
+  GCC_OPTION (flag_trapv) = saved_trapv;\
   folding_initializer = saved_folding_initializer;
 
 tree
@@ -16247,7 +16247,7 @@ tree_single_nonzero_warnv_p (tree t, bool *strict_overflow_p)
 	   so protect with -fdelete-null-pointer-checks; but not variables
 	   allocated on the stack.  */
 	if (DECL_P (base)
-	    && (flag_delete_null_pointer_checks
+	    && (GCC_OPTION (flag_delete_null_pointer_checks)
 		|| (DECL_CONTEXT (base)
 		    && TREE_CODE (DECL_CONTEXT (base)) == FUNCTION_DECL
 		    && auto_var_in_fn_p (base, DECL_CONTEXT (base)))))
@@ -16513,7 +16513,7 @@ fold_relational_const (enum tree_code code, tree type, tree op0, tree op1)
 	    case GT_EXPR:
 	    case GE_EXPR:
 	    case LTGT_EXPR:
-	      if (flag_trapping_math)
+	      if (GCC_OPTION (flag_trapping_math))
 		return NULL_TREE;
 	      result = 0;
 	      break;
diff --git a/gcc/fortran/arith.c b/gcc/fortran/arith.c
index 053cf76..fff0d36 100644
--- a/gcc/fortran/arith.c
+++ b/gcc/fortran/arith.c
@@ -294,7 +294,7 @@ gfc_check_integer_range (mpz_t p, int kind)
   i = gfc_validate_kind (BT_INTEGER, kind, false);
   result = ARITH_OK;
 
-  if (pedantic)
+  if (GCC_OPTION (pedantic))
     {
       if (mpz_cmp (p, gfc_integer_kinds[i].pedantic_min_int) < 0)
 	result = ARITH_ASYMMETRIC;
